package com.bergerkiller.bukkit.nolagg;

import com.bergerkiller.bukkit.nolagg.datapool.Pool;
import com.bergerkiller.bukkit.nolagg.datapool.PoolBuffer;
import com.bergerkiller.bukkit.nolagg.datapool.PoolData;

import net.minecraft.server.Chunk;
import net.minecraft.server.World;
import net.minecraft.server.WorldServer;

public class BufferedChunk extends Chunk implements PoolData<ChunkBuffer> {
	private static Pool<ChunkBuffer> pool = new Pool<ChunkBuffer>(42);
	public static String getBufferSizeName() {
		int size = 80 * pool.size();
		if (size < 1000) {
			return size + " kb";
		} else {
			return ((double) size / 1000) + " mb";
		}
	}
	
	public BufferedChunk(final World world, final int x, final int z) {
		super(world, x, z);
		this.buffer = pool.create(this);
		this.buffer.getData().apply(this);
	}

	private PoolBuffer<ChunkBuffer> buffer;
	@Override
	public ChunkBuffer getNewData() {
		return new ChunkBuffer();
	}
	
	public void setFree() {
		if (this.buffer != null) {
			this.buffer.setFree();
			this.buffer = null;
		}
	}
	
	public WorldServer getWorld() {
		return (WorldServer) this.world;
	}
	
	public boolean isUnloaded() {
		return this.getWorld().chunkProviderServer.chunks.get(this.x, this.z) != this;
	}

}